﻿package  
{
	import flash.display.Sprite;
	import idv.cjcat.stardust.common.actions.Age;
	import idv.cjcat.stardust.common.actions.DeathLife;
	import idv.cjcat.stardust.common.clocks.ImpulseClock;
	import idv.cjcat.stardust.common.initializers.Life;
	import idv.cjcat.stardust.common.math.UniformRandom;
	import idv.cjcat.stardust.threeD.actions.Move3D;
	import idv.cjcat.stardust.threeD.emitters.Emitter3D;
	import idv.cjcat.stardust.threeD.initializers.Position3D;
	import idv.cjcat.stardust.threeD.initializers.Velocity3D;
	import idv.cjcat.stardust.threeD.papervision3d.initializers.PV3DDisplayObject3DClass;
	import idv.cjcat.stardust.threeD.papervision3d.initializers.PV3DParticle;
	import idv.cjcat.stardust.threeD.zones.CubeZone;
	import idv.cjcat.stardust.threeD.zones.SinglePoint3D;
	import org.papervision3d.materials.special.MovieParticleMaterial;
	import org.papervision3d.materials.special.ParticleMaterial;
	
	public class RocketFlame2 extends Emitter3D
	{
		
		public var position:SinglePoint3D;
		
		public function RocketFlame2() 
		{
			super(new ImpulseClock(1));
			
			var particle:Sprite = new Sprite();
			particle.graphics.lineStyle(1, 0xE80000, 0.4);
			particle.graphics.drawCircle(0, 0, 22);
			particle.graphics.endFill();
			
			position = new SinglePoint3D();
			addInitializer(new Position3D(position));
			addInitializer(new PV3DParticle([new MovieParticleMaterial(particle)]));
			addInitializer(new Velocity3D(new CubeZone(-1, -1, 0, 2, 2, -4)));
			addInitializer(new Life(new UniformRandom(20, 1)));
			
			//actions
			addAction(new Age());
			addAction(new DeathLife());
			addAction(new Move3D());
		}
		
	}
	
}