﻿package  
{
	import flash.filters.BlurFilter;
	import idv.cjcat.stardust.threeD.papervision3d.renderers.PV3DParticleRenderer;
	import org.papervision3d.core.geom.Particles;
	import org.papervision3d.events.FileLoadEvent;
	import org.papervision3d.objects.DisplayObject3D;
	import org.papervision3d.objects.parsers.DAE;
	
	public class SpaceShip extends DisplayObject3D
	{
		
		private var model:DAE;
		private var holder:DisplayObject3D;
		private var particles:Particles;
		private var ready:Boolean = false;
		
		//stardust
		private var stardustRenderer:PV3DParticleRenderer;
		private var rocket1:Rocket;
		private var rocket2:Rocket;
		private var rocket3:Rocket;
		private var rocket4:Rocket;
		
		public function SpaceShip() 
		{
			holder = new DisplayObject3D();
			addChild(holder);

			model = new DAE();
			model.addEventListener(FileLoadEvent.LOAD_COMPLETE, modelLoaded);
			model.load('xwing/xwing.DAE'); 
		}
		
		private function modelLoaded(e:FileLoadEvent):void
		{
			model.removeEventListener(FileLoadEvent.LOAD_COMPLETE, modelLoaded);
			model.scale = 0.05;
			holder.addChild(model);
			
			particles = new Particles();
			holder.addChild(particles);
			particles.useOwnContainer = true;
			particles.filters = [new BlurFilter(16, 16, 1)];
			
			stardustRenderer = new PV3DParticleRenderer(particles);
			
			rocket1 = new Rocket(stardustRenderer, 30, -40, -190);
			rocket2 = new Rocket(stardustRenderer, 30, 40, -190);
			rocket3 = new Rocket(stardustRenderer, -30, -40, -190);
			rocket4 = new Rocket(stardustRenderer, -30, 40, -190);
			
			ready = true;
		}
		
		public function update(mouseDown:Boolean, rollAmount:Number):void
		{
			if (ready)
			{
				rocket1.update(mouseDown);
				rocket2.update(mouseDown);
				rocket3.update(mouseDown);
				rocket4.update(mouseDown);
			}
			
			if (mouseDown)
			{
				this.moveForward(30);
			}
			else
			{
				this.moveForward(10);
			}
			
			holder.localRotationZ = rollAmount;
		}
		
	}
	
}